
Sub DemoUpdate ()
   ' update example
   ' Databse = 
   ' nwind_v30.db
   ' Table = customers
   ' Record ID: CustomerID=CONSH
   ' Field: Address
   ' New content: 1203 Brewery Rd, Berkeley Gardens
   Dim SQL1 as String
   Dim SQL2 as String
   Dim SQL3 as String
   Dim SQL4 as String
   Dim N as Integer
   Dim S as String
   Dim T as String
   N=SQL3_DBopen("nwind_v30.db")
   SQL1="select CustomerID, CompanyName, Address from customers where CustomerID='CONSH';"
   SQL2="UPDATE customers SET Address='Oldworld Lane South' where CustomerID='CONSH';"
   SQL3="UPDATE customers SET Address='1203 Brewery Rd, Berkeley Gardens' where CustomerID='CONSH';"
   SQL4="UPDATE customers SET Address='Lackluster Suite 1203' where CustomerID='CONSH';"
   Print
   Print "Update example: Change address for customer 'CONSH'"
   S=SQL3QueryData (N,SQL1)
   Print "OLD Address"
   Print SQL3QueryHeader(N,SQL1)
   Print S;
   If Instr (S,"1203")>0 then 
       T=SQL3QueryData (N,SQL2)
   ElseIf Instr (S,"Oldworld")>0 then 
       T=SQL3QueryData (N,SQL4)
   Else
       T=SQL3QueryData (N,SQL3)
   End If
   Print
   Print "NEW Address"
   Print SQL3QueryHeader(N,SQL1)
   Print SQL3QueryData (N,SQL1);
   SQL3_DBclose(N)
   Sleep 
End Sub
   
Sub DemoExampleQueryData ()
	Dim N as Integer
    Dim I as Integer
    Dim J as Integer
    Dim X as Integer
    Dim S as String
    Dim SQL as String
    Print
    SQL="Select CustomerID, CompanyName, ContactName from customers LIMIT 10;"
	Print "Example of data for Query: " 
    Print SQL
    N=SQL3_DBopen("nwind_v30.db")
    X= SQL3QueryColCount(N,SQL)
    Print "Columns: " & X
    X= SQL3QueryRowCount(N,SQL)
    Print "Rows: " & X
    Print
    Print SQL3QueryHeader(N,SQL)
    Print SQL3QueryData (N,SQL)
	SQL3_DBclose(N)
    sleep
end Sub

Sub DemoTableData ()
	Dim N as Integer
    Dim X as Integer
    Dim I as Integer
    Dim J as Integer
    Dim S as String
    
	N=SQL3_DBopen("nwind_v30.db")
	'Print X
    'GetTableNamesAll(N)
	'For I= 1 to SQL3TableCount
    '    Print SQL3TableNames(I)
    'Next I
    GetTableNamesUsr(N)
    For I= 1 to SQL3TableCount
        Print
        Print "table: " & SQL3TableNames(I) &", ";
        GetColumnData(N,SQL3TableNames(I))
        Print SQL3ColumnCount & " Columns"
        For J= 1 to SQL3ColumnCount
            S= Left(SQL3ColumnNames(J) & Space(24),24) & _
               Left(SQL3ColumnTypes(J) & Space(24),24) & _
               SQL3ColumnNull(J) & ", " & SQL3ColumnPkey(J) & _
               ", " & Len(SQL3ColumnDefault(J))
            Print S
        Next J
        Print "press any key ...."
        Sleep
    Next I
    print
	SQL3_DBclose(X)
end Sub

Sub InsertEmployee (N as Integer, lastname as String, FirstName as String, Phone as String)
    Static ID as Integer
    ID=ID +1
    Dim SQL as String
    Dim T as String
    SQL="Insert Into Employees (EmployeeID,LastName,FirstName,HomePhone) " & _
        "Values (" & Str(ID) & ", '" & LastName & "', '" & FirstName & "', '" & _
        Phone & "');"
    T=SQL3QueryData (N,SQL)    
End Sub

Sub DemoInsert()
   Dim SQL as String
   Dim N as Integer
   Dim S as String
   Dim T as String
   N=SQL3_DBopen("nwind_v30.db")
   SQL="select EmployeeID,LastName,FirstName,HomePhone from Employees order by LastName, FirstName;"
   Print
   Print "Current Employee list"
   Print SQL3QueryHeader (N,SQL)
   Print SQL3QueryData (N,SQL)
   Print "press any key ..."
   sleep
   Print "Inserting new Employees"
   InsertEmployee(N,"Roggers","Alfred","324-234-7000")
   InsertEmployee(N,"Perry","Steven","263-978-2539")
   InsertEmployee(N,"Cruz","Carnival","800-555-1212")
   InsertEmployee(N,"Luck","Pot","900-555-2020")
   InsertEmployee(N,"Jones","Bill","561-323-1234")
   InsertEmployee(N,"Doe","John","602-512-4321")
   InsertEmployee(N,"Smith","Jane","888-222-3532")
   InsertEmployee(N,"White","Robert","701-222-1123")
   InsertEmployee(N,"Kane","Abel","233-287-1553")
   InsertEmployee(N,"Lee","Rose","253-227-1965")
   InsertEmployee(N,"AuH2o","Barry","433-271-6265")
   
   Print "New Employee List"
   Print SQL3QueryHeader (N,SQL)
   Print SQL3QueryData (N,SQL)
   SQL3_DBclose(N)
   sleep
End Sub
    
Sub DemoDumpToFile()
    Dim SQL1 as String
    Dim N as Integer
    SQL1="Select EmployeeID, LastName, FirstName, HomePhone from Employees order by LastName, FirstName;"
    Print "Dumping Employee names and Phone numbers to text file: EMPLOYEE.TXT"
    Open "EMPLOYEE.TXT" for output as #1
    N=SQL3_DBopen("nwind_v30.db")
    Print #1, SQL3QueryHeader(N,SQL1)
    Print #1, SQL3QueryData(N,SQL1)
    Close 1
    SQL3_DBclose(N)
    sleep
End Sub

Sub DemoDelete()
    Dim SQL1 as String
    Dim SQL2 as String
    Dim N as Integer
    Dim T as String
    N=SQL3_DBopen("nwind_v30.db")
    SQL1="select EmployeeID,LastName,FirstName,HomePhone from Employees;"
    SQL2="Delete from Employees Where EmployeeID>0;"
    Print "Current Employee list"
    Print SQL3QueryHeader (N,SQL1)
    Print SQL3QueryData (N,SQL1)
    Print "press any key ..."
    sleep
    Print "Deleting all employees"
    T=SQL3QueryData (N,SQL2)
    Print "New Employee list"
    Print SQL3QueryHeader (N,SQL1)
    Print SQL3QueryData (N,SQL1)
    SQL3_DBclose(N)
    sleep
end Sub

Sub InsertFreeBasic (N as Integer, KeyWord as String, Description as String)
    Static ID as Integer
    ID=ID +1
    Dim SQL as String
    Dim T as String
    SQL = "Insert Into FreeBasic (KeyWord,Description) Values ('" &   KeyWord & "', '" & Description & "');"
    T=SQL3QueryData (N,SQL)    
End Sub



Sub DemoNewTable()
    Dim SQL1 as String
    Dim SQL2 as String
    Dim SQL3 as String
    Dim N as Integer
    Dim T as String
    Dim S as String
    Dim K as String
    Dim V as String
    Dim P as Integer
    Print "Creating new Table 'FreeBasic'"
    sleep
    N=SQL3_DBopen("nwind_v30.db")
    SQL1="CREATE TABLE FreeBasic(Keyword TEXT, Description TEXT);"
    T=SQL3QueryData (N,SQL1)
    SQL2="Select * from FreeBasic order by Keyword;"
    SQL3="Drop Table FreeBasic;"
    InsertFreeBasic(N,"Print","Print outputs a list of values to the screen. Numeric values are converted to their string representation, with left padding for the sign. Objects of user-defined types must overload Operator Cast () As String.")
    InsertFreeBasic(N,"Circle","Circle will draw a circle, ellipse, or arc based on the parameters given to it.")
    InsertFreeBasic(N,"Left","Returns the leftmost n characters starting from the left (beginning) of str.")
    InsertFreeBasic(N,"Atan2","ATan2 returns the arctangent of the ratio y/x as a Double within the range of -Pi to Pi. The arctangent is the inverse of the Tan function. The returned angle is measured in radians (not degrees).")
    InsertFreeBasic(N,"Open","Opens a disk file for reading and/or writing. The file number file_num is bound to the file on disk, for use in subsequent file operations, such as Input # and Lock. The next available file number can be retrieved with FreeFile.")
    InsertFreeBasic(N,"Right","Returns the rightmost n characters starting from the right (end) of str.")
    InsertFreeBasic(N,"Clear","Clear sets one or more bytes in memory to a certain value (the default value is zero (0) if not specified). The starting address is taken from a reference to a variable or array element.")
    InsertFreeBasic(N,"Sleep","Sleep will wait until amount milliseconds (can be seconds in -lang qb, see below) given elapsed (if any value was passed) or until the user presses a key. If amount is below 100 ms then Sleep will always wait the full requested amount (key presses are ignored).")
    InsertFreeBasic(N,"Swap","Swaps the value of two variables.")
    InsertFreeBasic(N,"Close","Closes the files whose file numbers are passed as arguments. If an unused file number is passed, Close returns an error.")
    InsertFreeBasic(N,"DateSerial","Returns a date serial containing the date formed by the values in the year, month and day parameters.The date serial returned has no decimal part.")
    InsertFreeBasic(N,"Input #","Reads from a text file through a bound file number a delimiter-separated set of values and writes them in reading order into the variables in variable_list. If a variable is numeric the read value is converted from its string representation into the corresponding type.")
    S = SQL3QueryData (N,SQL2)
    While S<>""
        P=Instr(S,SQL3DLM)
        K=Left(S,P-1)
        S=Mid(S,P+1)
        P=Instr(S,SQL3EOL)
        V=Left(S,P-1)
        S=Mid(S,P+2)
        Print K
        Print V
        Print
    Wend
    T=SQL3QueryData (N,SQL1)
    Print "Table 'FreeBasic' Deleted"    
    SQL3_DBclose(N)
    sleep
End Sub
